// This script demonstrates how to use the setProp() 
// and getProp() methods, added in ImageJ 1.53a.
// SetProp and getProp() only work with strings, so
// it also shows how to encode non-string objects,
// such images, into strings.

  img = IJ.createImage("Untitled", "8-bit black", 500, 500, 3);
  clown = IJ.openImage("http://wsr.imagej.net/images/clown.jpg");
  bytes = new FileSaver(clown).serialize();
  string = Base64.getEncoder().encodeToString(bytes);
  img.setProp("clown", string);
  text = "Clown.jpg was serialized, set as an image\n"
     + "property, the image was saved, re-opened,\n"
     + "and clown.jpg was deserialized and displayed.";
  img.setProp("text", text);
  path = IJ.getDir("home")+"Downloads/Untitled.tif";
  IJ.saveAs(img, "Tiff", path);
  img2 = IJ.openImage(path);
  string2 = img2.getProp("clown");
  bytes2 = Base64.getDecoder().decode(string2);
  clown2 = new Opener().deserialize(bytes2);
  clown2.show();
  IJ.showMessage(img2.getProp("text"));
